import HistoryJSX from './history.js'
import JSXSensor from './Sensor.js'
import './App.css';
import React, { Component } from 'react';
import {Capteur,Donnees} from './model.js'
import mqtt from 'mqtt';
import {BrowserRouter as Router,Route, Redirect} from 'react-router-dom'
import ListeSensorJSX from './sensorList.js'





var Serveur = 'mqtt://127.0.0.1:8080'
var client = mqtt.connect(Serveur)


client.on('connect', function () {
  client.subscribe('#')
})
let SensorSListe= [];

//fonction
function CapteurEnList(nom, liste) {
  /* 
    args:
    nom(string): nom du capteur
    liste(liste): liste des capteurs

    return: 
    vrai si le nom existe
    faux si le nom n'existe pas
  */
  var i;
  for (i = 0; i < liste.length; i++) {
      if (liste[i].name === nom) {
          return true;
      }
  }
  return false;
}

function CapteurDeListe(nom, liste){
  /* 
    args:
    nom(string): nom capteur
    liste(liste): liste capteurs

    return: 
   capteur, si le capteur est dans la liste
  */
  var i;
  for (i = 0; i < liste.length; i++) {
      if (liste[i].name === nom) {
          return liste[i];
      }
  }
  console.log('#####################################"');
  return false;
}

class App extends Component {
  constructor(props) {
    super(props); 
    this.sensor = null;
    this.state = {value: '',liste: []};
    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.GetData();
  }
  handleChange(event) {
    this.setState({value: "/"+event.target.value});
  }
  handleSubmit(event) {
    return <Redirect to="" />;    
  }
   GetData(){
    let this_composont = this;
    client.on('message', function (topic, message) {
      
        // récuperer les message en type json
        var JsonData = JSON.parse(message.toString());
        // récuperer le nom du capteur
        var SensorName = topic.substring(6); 
      
        //récuperer la nouvelle valeur
        var Vval = JsonData['value'];
        
        //réccuperer le type du capteur
        var TypeSensor = JsonData['type'] 
      
        //create line for the table, with received data 
         
        //instance de capteur
        var InstanceSensor;
      
        // le capteur est il dans la liste
        if(!CapteurEnList(SensorName,SensorSListe)){
          //new instance Data 
          var _data = new Donnees([Vval]);
      
          //assign the created instance to InstanceSensor
          InstanceSensor= new Capteur(SensorName,TypeSensor,_data);

      
          //ajouter la nouvelle instance dans la liste
          SensorSListe.push(InstanceSensor);
    
      
        }else{
          // réccuperer l'instance de la liste
          InstanceSensor= CapteurDeListe(SensorName,SensorSListe);
    
          //inserer la valeur dans data.Values
          Array.prototype.push.apply(InstanceSensor.data.values, [Vval]);
          
          //add average column to the line
          }

          this_composont.setState({liste:SensorSListe});
      });
  }
  getSensorFromTheStateListe(name){
    /* 
      args:
      name(string): sensor name
      liste(liste): liste of sensors
  
      return: 
      sensor if sensor name is in the liste
    */
    var i;
    for (i = 0; i < this.state.liste.length; i++) {
        if (this.state.liste[i].name === name) {
            return this.state.liste[i];
        }
    }
  }
  render() {
    return (
      <Router>
      <div id="container">

        
          <header><center>
            <form onSubmit={this.handleSubmit} action={this.state.value}> 
                Broker :
                <input type="text" onChange={this.handleChange}/>
                <input type="submit" value="Submit" />
            </form> 
            </center>
          </header>
          <div className="wrapper">
            <nav>
                <ListeSensorJSX liste={this.state.liste}/>
            </nav>
            <article>
              <Route path="/:NomCapteur" render={(props) => {return <JSXSensor capteur={this.getSensorFromTheStateListe(props.match.params.NomDucapteur)} />}} />
            </article>
            <aside>
              <h3>Historique</h3>
              <Route path="/:NomCapteur" render={(props) => {return <HistoryJSX capteur={this.getSensorFromTheStateListe(props.match.params.NomDucapteur)} />}} />
            </aside>
          </div>
          <footer></footer>
        
       </div>
       </Router>
       
    );
  }
 
}

export default App;


